unit Main;

{ This program provides very simple examples of using Variant Arrays. Variant
  Arrays are Delphi's version of the Safe Arrays used in standard OLE
  programming.

  The code shown here provides examples of using both one dimensional and two
  dimensional variant arrays }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TVariantArrayForm = class(TForm)
    bOneDim: TButton;
    bTwoDim: TButton;
    procedure bOneDimClick(Sender: TObject);
    procedure bTwoDimClick(Sender: TObject);
  end;

var
  VariantArrayForm: TVariantArrayForm;

implementation

{$R *.DFM}

{ Simple example showing how to use a one dimensional variant array }

procedure TVariantArrayForm.bOneDimClick(Sender: TObject);
var
  MyVariant: Variant;
  S: string;
  I: Integer;
begin
  S := '';
  MyVariant := VarArrayCreate([0, 5], varVariant);
  for I := 0 to 5 do
    MyVariant[I] := I * 2;
  for I := 0 to 5 do
    S := S + ' ' + IntToStr(MyVariant[I]);

  ShowMessage(S);
end;

{ Simple example showing how to use a two dimensional variant array }

procedure TVariantArrayForm.bTwoDimClick(Sender: TObject);
var
  MyVariant: Variant;
  I, J: Integer;
  S: string;
begin
  S := '';

  MyVariant := VarArrayCreate([0, 5, 0, 5], varInteger);

  for I := 0 to 5 do
    for J := 0 to 5 do
      MyVariant[I, J] := I * J;

  for I := 0 to 5 do
  begin
    for J := 0 to 5 do
      S := S + IntToStr(MyVariant[I, J]) + ' ';
    S := S + #13;
  end;

  ShowMessage(S);
end;

end.
